#Lous C. Jones, Final Project

import os
import time
import math
import matplotlib
import matplotlib.pyplot as plt
import numpy as np
import glob
import ase.all
import atomwrite
from ase import cluster
from ase import Atoms
from ase.io import write
from ase.lattice.surface import *
from pylab import *
from ase.constraints import FixAtoms
from ase.optimize import QuasiNewton
from ase.lattice.surface import fcc111,add_adsorbate
from ase.lattice.surface import fcc111
from ase.lattice.surface import *
from ase.io import read
from ase import *
from ase import units
from ase.calculators.dacapo import *
from ase.calculators.emt import EMT

os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
import projectlib
os.chdir("C:\\Users\\LCJ\\")

UseVisual = False
if UseVisual:
    #import custom visualization library
    import atomvis

def Readxyz(xyzfile, Agfrac):
    Pos=[]
    Elements=[]
    Color=[]
    Radii=[]
    NAg=0
    os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
    f=file(xyzfile, "r").readlines()
    #print f[3], f[3][8:25], f[3][30:48],f[3][53:71]
    n=Agfrac*float(f[0])
    n=int(n)
    NAg=int(Agfrac*float(f[0]))
    print n, f[0]
        
    ct=0
    while n > 0: 
        if "Pt" in f[ct]:
            flip = np.random.rand()
            if flip > 0.5:
                flip = np.random.rand()
                if flip > 0.5:
                    f[ct]=f[ct].replace("Pt" ,"Ag")
                    n = n-1
        ct=ct+1
        if ct >= len(f):
            ct=0
    
        #print s
    i = file("cluster" + ".xyz" , "w")
    for s in f:
        i.write(str(s))
    i.close()
    #print file("cluster.xyz", "r").readlines()
    i = file("cluster.xyz", "r").readlines()
    Pos.append([[float(s[7:25]),float(s[30:48]),float(s[53:71])] for s in i if "0000" in s])
    Elements.append([(s[0:2]) for s in i if "0000" in s]) 
    for s in i:
        if "Pt" in s:            
            Color.append((0,1,0))
            Radii.append(.5)
        if "Ag" in s:            
            Color.append((1,0,0))
            Radii.append(1.72)     
    return Pos, Elements, f[0], NAg, Color, Radii
    
def ReadWritexyz(xyzfile):
    Pos=[]
    os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
    f=file(xyzfile, "r").readlines()
    i = file("Cluster" + ".xyz" , "w")
    for s in f:
        i.write(str(s))
    i.close()
    #print file("cluster.xyz", "r").readlines()
    i = file("Cluster.xyz", "r").readlines()
    Pos.append([[float(s[7:25]),float(s[30:48]),float(s[53:71])] for s in i if "." in s])
#    Elements.append([[(s[0:2])] for s in i if "." in s]) 
#    for s in i:
#        if "Pt" in s:            
#            Color.append((0,1,0))
#            Radii.append(1.75)
#        if "Ag" in s:            
#            Color.append((1,0,1))
#            Radii.append(1.72)
    return Pos

#        
#PosOct=np.array(PosOct[0])
#        
#i=0        
#while i < 10:
#    MoveAtom1 = np.random.randint(len(PosOct))
#    MoveAtom2 = np.random.randint(len(PosOct))
#    if MoveAtom1 != MoveAtom2:
#        #print PosOct[MoveAtom1], PosOct[MoveAtom2]
#        OldPos1 = PosOct[MoveAtom1].copy()
#        OldPos2 = PosOct[MoveAtom2].copy()
#        PosOct[MoveAtom1]=OldPos2
#        PosOct[MoveAtom2]=OldPos1
#        #print PosOct[MoveAtom1], PosOct[MoveAtom2]
#        i=i+1     

#dyn = QuasiNewton(slab)
#dyn.run(fmax=.9, steps=10**7)
#e_slab=slab.get_potential_energy()
#forces=slab.get_forces(apply_constraint=False)

os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
import ex3lib
os.chdir("C:\\Users\\LCJ\\")
#NOTE:
#Everything below assumes unit atomic masses,
#such that forces = accelerations.


def LineSearch(Pos, Dir, dx, EFracTol,
               Accel = 1.5, MaxInc = 10., MaxIter = 10000):
    """Performs a line search along direction Dir.
Input:
    Pos: starting positions, (N,3) array
    Dir: (N,3) array of gradient direction
    dx: initial step amount
    EFracTol: fractional energy tolerance
    Accel: acceleration factor
    MaxInc: the maximum increase in energy for bracketing
    MaxIter: maximum number of iteration steps
Output:
    PEnergy: value of potential energy at minimum along Dir
    Pos: minimum energy (N,3) position array along Dir
"""
    #identify global variables
    global M, L, Cut, Lbox
    
    #start the iteration counter
    Iter = 0

    #find the normalized direction    
    NormDir = np.clip(Dir, -1.e100, 1.e100)
    NormDir = NormDir / np.sqrt(np.sum(NormDir * NormDir))

    #take the first two steps and compute energies    
    Dists = [0., dx]
    PEs = [ex3lib.calcenergy(Pos + NormDir * x, M, L, Cut) for x in Dists]
    
    #if the second point is not downhill in energy, back
    #off and take a shorter step until we find one
    while PEs[1] > PEs[0]:
        Iter += 1
        dx = dx * 0.5
        Dists[1] = dx
        PEs[1] = ex3lib.calcenergy(Pos + NormDir * dx, M, L, Cut)
        
    #find a third point
    Dists = Dists + [2. * dx]
    PEs = PEs + [ex3lib.calcenergy(Pos + NormDir * 2. * dx, M, L, Cut)]
    
    #keep stepping forward until the third point is higher
    #in energy; then we have bracketed a minimum
    while PEs[2] < PEs[1]:
        Iter += 1
            
        #find a fourth point and evaluate energy
        Dists = Dists + [Dists[-1] + dx]
        PEs = PEs + [ex3lib.calcenergy(Pos + NormDir * Dists[-1], M, L, Cut)]

        #check if we increased too much in energy; if so, back off
        if (PEs[3] - PEs[0]) > MaxInc * (PEs[0] - PEs[2]):
            PEs = PEs[:3]
            Dists = Dists[:3]
            dx = dx * 0.5
        else:
            #shift all of the points over
            PEs = PEs[-3:]
            Dists = Dists[-3:]
            dx = dx * Accel
            
    #we've bracketed a minimum; now we want to find it to high
    #accuracy
    OldPE3 = 1.e300
    while True:
        Iter += 1
        if Iter > MaxIter:
            print "Warning: maximum number of iterations reached in line search."
            break
            
        #store distances for ease of code-reading
        d0, d1, d2 = Dists
        PE0, PE1, PE2 = PEs

        #use a parobolic approximation to estimate the location
        #of the minimum
        d10 = d0 - d1
        d12 = d2 - d1
        Num = d12*d12*(PE0-PE1) - d10*d10*(PE2-PE1)
        Dem = d12*(PE0-PE1) - d10*(PE2-PE1)
        if Dem == 0:
            #parabolic extrapolation won't work; set new dist = 0 
            d3 = 0
        else:
            #location of parabolic minimum
            d3 = d1 + 0.5 * Num / Dem
            
        #compute the new potential energy
        PE3 = ex3lib.calcenergy(Pos + NormDir * d3, M, L, Cut)
        
        #sometimes the parabolic approximation can fail;
        #check if d3 is out of range < d0 or > d2 or the new energy is higher
        if d3 < d0 or d3 > d2 or PE3 > PE0 or PE3 > PE1 or PE3 > PE2:
            #instead, just compute the new distance by bisecting two
            #of the existing points along the line search
            if abs(d2 - d1) > abs(d0 - d1):
                d3 = 0.5 * (d2 + d1)
            else:
                d3 = 0.5 * (d0 + d1)
            PE3 = ex3lib.calcenergy(Pos + NormDir * d3, M, L, Cut)
            
        #decide which three points to keep; we want to keep
        #the three that are closest to the minimum
        if d3 < d1:
            if PE3 < PE1:
                #get rid of point 2
                Dists, PEs = [d0, d3, d1], [PE0, PE3, PE1]
            else:
                #get rid of point 0
                Dists, PEs = [d3, d1, d2], [PE3, PE1, PE2]
        else:
            if PE3 < PE1:
                #get rid of point 0
                Dists, PEs = [d1, d3, d2], [PE1, PE3, PE2]
            else:
                #get rid of point 2
                Dists, PEs = [d0, d1, d3], [PE0, PE1, PE3]
                
        #check how much we've changed
        if abs(OldPE3 - PE3) < EFracTol * abs(PE3):
            #the fractional change is less than the tolerance,
            #so we are done and can exit the loop
            break
        OldPE3 = PE3

    #return the position array at the minimum (point 1)        
    PosMin = Pos + NormDir * Dists[1]
    PEMin = PEs[1]

    #if using visualization, update the display
    if UseVisual:
        if atomvis.Initialized:
            #update the positions
            atomvis.Update(PosMin)
        else:
            #initialize the visualization window
            atomvis.Init(PosMin, AtomRadiusDflt=2.7, \
            AtomColorDflt=(0, 1, 0), BoxColor=(0, 0, 1), \
            BackColor=(1, 1, 1), DisplayFreq=0.1)
        
    return PEMin, PosMin

        
def ConjugateGradient(Pos, dx, EFracTolLS, EFracTolCG):
    """Performs a conjugate gradient search.
Input:
    Pos: starting positions, (N,3) array
    dx: initial step amount
    EFracTolLS: fractional energy tolerance for line search
    EFracTolCG: fractional energy tolerance for conjugate gradient
Output:
    PEnergy: value of potential energy at minimum
    Pos: minimum energy (N,3) position array 
"""
    #identify global variables
    global M, L, rc, Cut
    #initial search direction
    Forces = np.zeros_like(Pos)
    PE, Forces = ex3lib.calcenergyforces(Pos, M, L, rc)
    Dir = Forces
    OldPE = 1.e300
    #iterative line searches
    while abs(PE - OldPE) > EFracTolCG * abs(PE):
        OldPE = PE
        PE, Pos = LineSearch(Pos, Dir, dx, EFracTolLS)
        OldForces = Forces.copy()
        PE, Forces = ex3lib.calcenergyforces(Pos, M, L, rc)
        Gamma = np.sum((Forces - OldForces) * Forces) / np.sum(OldForces * OldForces)
        Dir = Forces + Gamma *  Dir
    return PE, Pos           



    
def InitPositions(N, L):
    """Returns an array of initial positions of each atom,
placed on a cubic lattice for convenience.
Input:
    N: number of atoms
    L: box length
Output:
    Pos: (N,3) array of positions
"""

    Pos = np.zeros((N,3), float)
    #compute integer grid # of locations for cubic lattice
    NLat = int(N**(1./3.) + 1.)
    LatSpac = L / NLat
    #make an array of lattice sites
    r = LatSpac * np.arange(NLat, dtype=float) - 0.5*L
    #loop through x, y, z positions in lattice until done
    #for every atom in the system
    i = 0
    for x in r:
        for y in r:
            for z in r:
                Pos[i] = np.array([x,y,z], float)
                #add a random offset to help initial minimization
                Offset = 0.1 * LatSpac * (np.random.rand(3) - 0.5)
                Pos[i] = Pos[i] + Offset
                i += 1
                #if done placing atoms, return
                if i >= N:
                    return Pos
    return Pos    
    


def RescaleVelocities(Vel, T):
    """Rescales velocities in the system to the target temperature.
Input:
    Vel: (N,3) array of atomic velocities
    T: target temperature
Output:
    Vel: same as above
"""
    #recenter to zero net momentum (assuming all masses same)
    Vel = Vel - Vel.mean(axis=0)
    #find the total kinetic energy
    KE = 0.5 * np.sum(Vel * Vel)
    #find velocity scale factor from ratios of kinetic energy
    VScale = np.sqrt(1.5 * len(Vel) * T / KE)
    Vel = Vel * VScale
    return Vel  

def RescaleVelocitiesKE(Vel, KEavg):
    """Rescales velocities in the system to the target temperature.
Input:
    Vel: (N,3) array of atomic velocities
    T: target temperature
Output:
    Vel: same as above
"""
    #recenter to zero net momentum (assuming all masses same)
    Vel = Vel - Vel.mean(axis=0)
    #find the total kinetic energy
    KE = 0.5 * np.sum(Vel * Vel)
    #find velocity scale factor from ratios of kinetic energy
    VScale = np.sqrt(KEavg / KE)
    Vel = Vel * VScale
    return Vel  


def InitVelocities(N, T):
    """Returns an initial random velocity set.
Input:
    N: number of atoms
    T: target temperature
Output:
    Vel: (N,3) array of atomic velocities
"""
    Vel = np.random.rand(N, 3)
    Vel = RescaleVelocities(Vel, T)
    return Vel


def InitAccel(Pos):
    """Returns the initial acceleration array.
Input:
    Pos: (N,3) array of atomic positions
Output:
    Accel: (N,3) array of acceleration vectors
"""
    #global variables
    global M, L, rc
    #get the acceleration from the forces
    PEnergy, Accel = ex3lib.calcenergyforces(Pos, M, L, rc)
    return Accel


def InstTemp(Vel):
    """Returns the instantaneous temperature.
Input:
    Vel: (N,3) array of atomic velocities
Output:
    Tinst: float
"""
    return np.sum(Vel * Vel) / (3. * len(Vel))

PtOct=ase.cluster.Octahedron('Pt', 10, cutoff=0, alloy=False)
#PtIcos=ase.cluster.Icosahedron('Pt', 6, latticeconstant=5.4)
#PtIcos.center(vacuum=0,axis=None)
#PtCube=fcc111('Pt', size=(8,8,8), vacuum=10.0)
#PtWulff=ase.cluster.wulff.wulff_construction('Pt', surface, [1,1,1,1,1,1,1,1,1,1,1,1], 600, "fcc", rounding="closest", latticeconstant=5.4)
os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
write('PtOct.xyz', PtOct) 

#write('PtIcos.xyz',PtIcos)
#write('PtCube.xyz',PtCube)
#write('PtWulff.xyz',PtWulff)
PosOct, Elements, N, NAg, Color, Radii=Readxyz("PtOct.xyz", .09)
Natom=float(N)
Names = list(flatten(Elements[0]))
Cluster = read('cluster.xyz')
print Cluster.positions
Pdb = atomwrite.pdbfile("animOctd3.pdb", AtomNames = Names)

Pdb.write(Cluster.positions)

#PosIcos, Elements=Readxyz("PtIcos.xyz", 1)
#PosCube, Elements=Readxyz("PtCube.xyz", 1)
#PosWulff=Readxyz("PtWulff.xyz")
#print np.max(np.array(Pos))
#print len(Pos[0]), np.sqrt(np.sum(np.array(Pos[0][len(Pos[0])-1])**2))
#print len(PosOct[0]), PosOct[0][0]


        
Cluster.center
Cluster.set_calculator(EMT())
e_slab = Cluster.get_potential_energy()
print e_slab
shuffle(Cluster.positions)

#forces=Cluster.get_forces(apply_constraint=False)
dyn = QuasiNewton(Cluster)
dyn.run(fmax=1, steps=10**5)
e_slab = Cluster.get_potential_energy()
print e_slab

Pos=Cluster.positions
print Pos, np.array(PosOct[0])
Pdb.write(Pos)
if UseVisual:
    if atomvis.Initialized:
        #update the positions
        atomvis.Update(Pos)
    else:
        #initialize the visualization window
        Names = list(flatten(Elements[0]))
        atomvis.Init(Pos, AtomTypes=Names, AtomColor=Color, \
        AtomRadius=Radii, BoxColor=(0, 0, 1), \
        BackColor=(1, 1, 1), DisplayFreq=0.1)


CenterofMass=Cluster.get_center_of_mass()
Pos=Cluster.positions
Elements=np.array(Cluster.get_chemical_symbols())

Aggr, Ptgr=projectlib.calcradialdists(Pos, Elements, CenterofMass, NAg)


#a=np.histogram(Aggr,bins=10, range=(0,17))
#c=np.append(a, b)
#print len(c[0]), len(c[1]), a[0], a[1]

#p=len(c)-2
#while p > 0:
#    c[0]=c[0]+c[p]
#    p=p-2
#    print c[0], p, len(c[0]), len(c[1])
#
#
#c[0]=2.*c[0]/float(len(c)
Aggr=list(np.sort(Aggr))
Ptgr=list(np.sort(Ptgr))
   
Agnum=[]
Agrad=[]
Ptrad=[]
Ptnum=[]

i=0
for s in Aggr:
    Agrad=Agrad + [s]
    i=i+1
    Agnum=Agnum + [float(i)]
Agrad=np.array(Agrad)
Agnum=np.array(Agnum)

plt.plot(Agrad, Agnum, 'ro')
show()

i=0
for s in Ptgr:
    Ptrad=Ptrad + [s]
    i=i+1
    Ptnum=Ptnum + [float(i)]
        
Ptrad=np.array(Ptrad)
Ptnum=np.array(Ptnum)


plt.plot(Ptrad, Ptnum, 'bo')
show()

plt.hist(Agrad, bins=21, range=(3,24), color=(1,0,0))  
show()
plt.hist(Ptrad, bins=21, color=(0,0,1), range=(3,24))  
show()

T=573.0
kT=(8.617*10**-5)*T

#f = file("dataHW3d M = " + str(i) + ".txt", "w")
ViewFreq = 1
st = 0

z=0
Aglocs=np.array([])
for s in Cluster.get_chemical_symbols():
    if "Ag" in Cluster.get_chemical_symbols()[z]:
        Aglocs=np.append(Aglocs,z)
    z=z+1
    
z=0
Ptlocs=np.array([])
for s in Cluster.get_chemical_symbols():
    if "Pt" in Cluster.get_chemical_symbols()[z]:
        Ptlocs=np.append(Ptlocs,z)
    z=z+1
    
sweepct = 0
MCsweeps = 6
i=0.
attempts=0.
Sweeps=np.array([])
Energys=np.array([])

    
while sweepct < MCsweeps:
    MoveAtom1 = int(Aglocs[np.random.randint(len(Aglocs))])
    MoveAtom2 = int(Ptlocs[np.random.randint(len(Ptlocs))])
    OldPE = Cluster.get_potential_energy()
    OldPos1 = Cluster[MoveAtom1].position
    OldPos2 = Cluster[MoveAtom2].position
    posis=[]
    posis.append(list(OldPos1))
    posis.append(list(OldPos2))
    attempts=attempts+1
    Cluster[MoveAtom1].position=np.array(posis[1])
    #print OldPos1, OldPos2, posis[0], posis[1]
    Cluster[MoveAtom2].position=np.array(posis[0])
    tempCluster=Cluster
    dyn = QuasiNewton(Cluster)
    dyn.run(fmax=1, steps=10**5)
    NewPE = Cluster.get_potential_energy()
    if np.abs((NewPE-OldPE)/kT) < 709:
        P12 = min(1 , math.exp(-(NewPE-OldPE)/kT))
        #print P12
        flip = np.random.rand()
        oldi=i
        if P12 != 1 and flip > P12:
            Cluster=tempCluster
            Cluster[MoveAtom1].position=np.array(posis[0])
            Cluster[MoveAtom2].position=np.array(posis[1])
        else:
            i=i+1.
            print NewPE, i/attempts, i, i/NAg, sweepct, MCsweeps
#            print NewPE, i/attempts, i, int(float(Natom)/8.), sweepct
        if oldi != i:
            if i % int(float(NAg)/1.) == 0:
                sweepct = sweepct + 1
#                Sweeps=np.append(Sweeps,sweepct)
#                Energys=np.append(Energys, NewPE)
            
            if i % ViewFreq == 0:
#                write('Cluster.xyz', Cluster)
                Pos=Cluster.positions
                Pdb.write(Pos)
                if UseVisual:
                    if atomvis.Initialized:
                        #update the positions
                        atomvis.Update(Pos)
                    else:
                        #initialize the visualization window
                        Names = list(flatten(Elements[0]))
                        atomvis.Init(Pos, AtomTypes=Names, AtomColor=Color, \
                        AtomRadius=Radii, BoxColor=(0, 0, 1), \
                        BackColor=(1, 1, 1), DisplayFreq=0.1)
                        
Pdb.close()

#plt.plot(Sweeps, Energys, 'ro')
#show()

sweepct = 0
MCsweeps = 3
i=0.
attempts=0.
Sweeps=np.array([0])

CenterofMass=Cluster.get_center_of_mass()
Aggr, Ptgr=projectlib.calcradialdists(Pos, Elements, CenterofMass, NAg)

Aggr=histogram(Aggr, bins=21, range=(3,24))
Ptgr=histogram(Ptgr, bins=21, range=(3,24))

while sweepct < MCsweeps:
    MoveAtom1 = int(Aglocs[np.random.randint(len(Aglocs))])
    MoveAtom2 = int(Ptlocs[np.random.randint(len(Ptlocs))])
    OldPE = Cluster.get_potential_energy()
    OldPos1 = Cluster[MoveAtom1].position
    OldPos2 = Cluster[MoveAtom2].position
    posis=[]
    posis.append(list(OldPos1))
    posis.append(list(OldPos2))
    attempts=attempts+1
    Cluster[MoveAtom1].position=np.array(posis[1])
    #print OldPos1, OldPos2, posis[0], posis[1]
    Cluster[MoveAtom2].position=np.array(posis[0])
    tempCluster=Cluster
    dyn = QuasiNewton(Cluster)
    dyn.run(fmax=1, steps=10**5)
    NewPE = Cluster.get_potential_energy()
    if np.abs((NewPE-OldPE)/kT) < 709:
        P12 = min(1 , math.exp(-(NewPE-OldPE)/kT))
        flip = np.random.rand()
        oldi=i
        if P12 != 1 and flip > P12:
            Cluster=tempCluster
            Cluster[MoveAtom1].position=np.array(posis[0])
            Cluster[MoveAtom2].position=np.array(posis[1])
        else:
            i=i+1
            print NewPE, i/attempts, i/NAg, sweepct, MCsweeps
        
        if oldi != i:
                
            if i % NAg == 0:
                CenterofMass=Cluster.get_center_of_mass()
                Aggrdum, Ptgrdum=projectlib.calcradialdists(Pos, Elements, CenterofMass, NAg)
                Aggr= list(Aggr) + list(histogram(Aggrdum, bins=21, range=(3,24)))
                Ptgr=list(Ptgr) + list(histogram(Ptgrdum, bins=21, range=(3,24)))
                sweepct = sweepct + 1
#            if i % ViewFreq == 0:
#                write('Cluster.xyz', Cluster)
#                Pos=ReadWritexyz("Cluster.xyz")
#                #print len(Aggr), len(Ptgr)
##                        plt.hist(Aggr, bins=20, color=(1,0,0))  
##                        show()
##                        plt.hist(Ptgr, bins=20, color=(0,0,1))  
##                        show()
#                if UseVisual:
#                    if atomvis.Initialized:
#                        #update the positions
#                        atomvis.Update(Pos[0])
#                        #Pdb.write(np.array(Pos[0]))
#                    else:
#                        #initialize the visualization window
#                        Names = list(flatten(Elements[0]))
#                        atomvis.Init(Pos[0], AtomTypes=Names, AtomColor=Color, \
#                        AtomRadius=Radii, BoxColor=(0, 0, 1), \
#                        BackColor=(1, 1, 1), DisplayFreq=0.1)

#Pdb.close()
p=len(Aggr)-2
print len(Aggr)
Aggrs=np.array(Aggr[0])*0
while p >= 0:
    Aggrs=Aggrs+Aggr[p]
    p=p-2
    
Aggrs=Aggrs/float(len(Aggr)/2.)
print Aggrs

p=len(Ptgr)-2
Ptgrs=np.array(Ptgr[0])*0
while p >= 0:
    Ptgrs=Ptgrs+Ptgr[p]
    p=p-2 
Ptgrs=Ptgrs/float(len(Ptgr)/2.)  

p=len(Aggr)-2
Aggrerr=np.array(Aggr[0])*0
while p >= 0:
    Aggrerr=Aggrerr + (Aggr[p]-Aggrs)**2
    p=p-2

p=len(Ptgr)-2
Ptgrerr=np.array(Ptgr[0])*0
while p >= 0:
    Ptgrerr=Ptgrerr + (Ptgr[p]-Ptgrs)**2
    p=p-2


Aggrerr=np.sqrt(Aggrerr)
Ptgrerr=np.sqrt(Ptgrerr)
   

os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
f = file("Aggrmeanrse" + ".txt", "w")
den=np.sum(Aggrs)+np.sum(Ptgrs)
Aggrerr=np.sqrt(Aggrerr)/(den)
Aggrs=Aggrs/(den)
for s in list(Aggrs):
    f.write(str(s) + "\n")
f.close


os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
f = file("Ptgrmeanrse" + ".txt", "w")

Ptgrerr=np.sqrt(Ptgrerr)/(den)
Ptgrs=Ptgrs/(den)

for s in list(Ptgrs):
    f.write(str(s) + "\n")
f.close

os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
f = file("Aggrmeanerrorse" + ".txt", "w")
for s in list(Aggrerr):
    f.write(str(s) + "\n")
f.close

os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
f = file("Ptgrmeanerrorse" + ".txt", "w")
for s in list(Ptgrerr):
    f.write(str(s) + "\n")
f.close

os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
f = file("Aggrmeanrade" + ".txt", "w")
p=1
Aggrad=np.array([])
while p < len(Aggr[1]):
    f.write(str((Aggr[1][p]+Aggr[1][p-1])/2.) + "\n") 
    Aggrad=np.append(Aggrad, (Aggr[1][p]+Aggr[1][p-1])/2.)     
    p=p+1
f.close()

os.chdir("C:\\Users\\LCJ\\Documents\\Research Topics\\UCSB\\Classes\\ChE 210D, simulations\\Python codes")
f = file("Ptgrmeanrade" + ".txt", "w")
p=1
Ptgrad=np.array([])
while p < len(Ptgr[1]):
    f.write(str((Ptgr[1][p]+Ptgr[1][p-1])/2.) + "\n") 
    Ptgrad=np.append(Ptgrad, (Ptgr[1][p]+Ptgr[1][p-1])/2.)     
    p=p+1
f.close()

Agraddens=np.array([])
p=0
sold=0.
for s in Aggrs:
    sold=s+sold
    Agraddens=np.append(Agraddens, (sold/Aggrad[p]**3.)*(np.max(Aggrad)**3.))
    p=p+1

Ptraddens=np.array([])
p=0
sold=0.
for s in Ptgrs:
    sold=s+sold
    Ptraddens=np.append(Ptraddens, (sold/Ptgrad[p]**3.)*(np.max(Ptgrad)**3.))
    p=p+1
print "done"

plt.errorbar(Aggrad, Aggrs, yerr=Aggrerr,ecolor='red')
plt.errorbar(Ptgrad, Ptgrs, yerr=Ptgrerr,ecolor='blue')

show()   

plt.plot(Aggrad, Agraddens, 'ro')
plt.plot(Ptgrad, Ptraddens, 'bo')

show()
   

